﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Bitmap_GetSkeletonDisplay
{
    class NTL_FIFO
    {
        //***************************************************************
        //【配列をFIFOとして使うためのクラス】
        //***************************************************************
        private const int default_nFIFO = 60; //【FIFO段数】Default 30FPSで2秒分に相当
        private int nFIFO = default_nFIFO;    //【FIFO段数】
        private int wPtr;                     //【FIFO書込みポインタ】
        private int rPtr;                     //【FIFO読出しポインタ】
        private bool FIFOfull = false;        //【FIFOフル】
        private bool FIFOempty = true;        //【FIFO空】

        public void Initialize(int n)
        {
            wPtr = 0;
            rPtr = 0;
            nFIFO = n;
            FIFOempty = true;
            FIFOfull = false;
        }

        public void Initialize()
        {
            wPtr = 0;
            rPtr = 0;
            nFIFO = default_nFIFO;
            FIFOempty = true;
            FIFOfull = false;
        }

        public void Push()
        {
            wPtr++;
            FIFOempty = false;
            if (wPtr == nFIFO) { wPtr = 0; }
            if (wPtr == rPtr) { FIFOfull = true; }
        }

        public void Pop()
        {
            rPtr++;
            if (rPtr == nFIFO) { rPtr = 0; }
            if (rPtr == wPtr) { FIFOempty = true; }
        }

        public int ReadPointer
        {
            set { rPtr = value; }
            get { return rPtr; }
        }

        public int WritePointer
        {
            set { wPtr=value; }
            get { return wPtr; }
        }

        public bool Full
        {
            get { return FIFOfull; }
        }
        public bool Empty
        {
            get { return FIFOempty; }
        }
        public int Length
        {
            get { return nFIFO; }
        }

    }
}
